// -*- C++ -*-

/* 
 * apptracker.cc
 *
 * Copyright (C) 1998 EMC Capital Management, Inc.
 *
 * Developed by Jon Trowbridge <trow@emccta.com> and
 * Havoc Pennington <hp@emccta.com>.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#include <algo.h>

#include "apptracker.h"

///////////////////////////////// App management

AppTracker::~AppTracker()
{
  list<Gnome_App*>::iterator i = apps_.begin();
  while ( i != apps_.end() ) {
    delete *i;
    ++i;
  }
}

void
AppTracker::add_app(Gnome_App* a)
{
  g_return_if_fail(a != 0);

  apps_.push_back(a);

  connect_to_method(a->destroy, this, &AppTracker::remove_app,a);
}

void
AppTracker::remove_app(Gnome_App* a)
{
  list<Gnome_App* >::iterator i;
  i = find(apps_.begin(), apps_.end(), a);
  if (i != apps_.end()) {
    apps_.erase(i);
  }
#ifdef G_ENABLE_CHECKS
  else {
    g_warning("Didn't find app in remove_app\n");
  }
#endif
}
