// -*- C++ -*-

/* 
 * columndoc.cc 
 *
 * Copyright (C) 1998 EMC Capital Management, Inc.
 *
 * Developed by Jon Trowbridge <trow@emccta.com> and
 * Havoc Pennington <hp@emccta.com>.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#include "columndoc.h"
#include <libgnome/libgnome.h>

ColumnDoc::ColumnDoc() : Named(_("Untitled Column")), 
  data_(0)
{
  g_warning("Creating ColumnDoc with no DataColumn, not sure this works.");

}

ColumnDoc::ColumnDoc(DataSet & ds) : Named(_("Untitled Column")),
  data_(&ds)
{

}

ColumnDoc::~ColumnDoc()
{
  if (data_ != 0) delete data_;
  destroy(*this);
}

string 
ColumnDoc::serialize() const
{
  // This is just a lame test routine.
  string output;

  output = "ColumnDoc\n" + get_name() + '\n';

  size_t i = 0;
  size_t n = data_->size();

  while ( i < n ) {
    char buf[30]; 
    g_snprintf(buf,30,"%f\n",data_->data(i));
    output += buf;
    ++i;
  }  

  return output;
}

int
ColumnDoc::unserialize(const string & s)
{
  // stupid implementation for testing; no error checks

  data_ = new DataSet;

  int pos = 0;
  int size = s.size();

  g_print("ColumnDoc is unserializing:\n%s\n", s.c_str());

  int endofname = s.find_first_of('\n',pos);
  set_name(s.substr(pos,endofname-pos));
  g_print("Column name: %s\n", s.substr(pos,endofname-pos).c_str());

  pos = endofname + 1;
  double n = 0.0;  // fake data for now. fixme
  
  while (pos < size) {
    int newline = s.find_first_of('\n',pos);

    data_->add(n);

    //    column_->add(s.substr(pos,newline-pos));

    // fixme for now this just segfaults if you exceed
    //  DataSet's default size.

    pos = newline + 1;
    n += 5.0;
  }  

  return pos; // no error checking to cause a -1
}




