// -*- C++ -*-

/* 
 * columnimporterstore.h 
 *
 * Copyright (C) 1998 EMC Capital Management, Inc.
 *
 * Developed by Jon Trowbridge <trow@emccta.com> and
 * Havoc Pennington <hp@emccta.com>.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#ifndef GUPPI_COLUMNIMPORTERSTORE_H
#define GUPPI_COLUMNIMPORTERSTORE_H

#include <vector>

#include "importer.h"
#include "columndoc.h"

// This could maybe be yet another template in importer.h,
//  but I'm thinking more flexibility might be desired at this level.

class ColumnImporterStore : public ImporterStore<Importer<ColumnDoc> > {
public:
  ColumnImporterStore() {}
  virtual ~ColumnImporterStore() {}

  // sorry for the typedef, I just don't feel like typing this...
  typedef ImporterProxyInterface<Importer<ColumnDoc> > column_importer;

  typedef vector<column_importer*>::const_iterator const_iterator;

  const_iterator begin() const { return importers_.begin(); }
  const_iterator end()   const { return importers_.end(); }
  size_t         size()  const { return importers_.size(); }
  
  virtual void 
  register_importer(column_importer & ci) {
    importers_.push_back(&ci);
  }

  virtual const ImporterProxyInterface<Importer<ColumnDoc> > &
  get_proxy_number(size_t i) const { 
    return *(importers_[i]);
  }

private:
  vector<column_importer*> importers_;
};

extern ColumnImporterStore global_column_importer_store;

#endif
