// -*- C++ -*-

/* 
 * dialogtracker.cc
 *
 * Copyright (C) 1998 EMC Capital Management, Inc.
 *
 * Developed by Jon Trowbridge <trow@emccta.com> and
 * Havoc Pennington <hp@emccta.com>.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#include <algo.h>

#include "dialogtracker.h"

///////////////////////////////// Dialog management

DialogTracker::~DialogTracker()
{
  list<Gnome_Dialog*>::iterator i = dialogs_.begin();
  while ( i != dialogs_.end() ) {
    (*i)->hide();
    delete *i;
    ++i;
  }
}

void
DialogTracker::add_dialog(Gnome_Dialog* d)
{
  g_return_if_fail(d != 0);

  dialogs_.push_back(d);

  connect_to_method(d->close, this, &DialogTracker::remove_dialog,d);
}

gboolean
DialogTracker::remove_dialog(Gnome_Dialog* d)
{
  list<Gnome_Dialog* >::iterator i;
  i = find(dialogs_.begin(), dialogs_.end(), d);
  if (i != dialogs_.end()) {
    dialogs_.erase(i);
  }
#ifdef G_ENABLE_CHECKS
  else {
    g_warning("Didn't find dialog in remove_dialog\n");
  }
#endif
  return 0; // don't override destroy/hide
}

