// -*- C++ -*-

/* 
 * gtkaxis.h 
 *
 * Copyright (C) 1998 EMC Capital Management, Inc.
 *
 * Developed by Jon Trowbridge <trow@emccta.com> and
 * Havoc Pennington <hp@emccta.com>.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#ifndef GUPPI_GTKAXIS_H
#define GUPPI_GTKAXIS_H

#include <list>
#include <gtk--draw.h>
#include <gtk--plot.h>
#include "rubberband.h"

class Gtk_Axis : public Gtk_DrawingBuffer,
		 public Gdk_Draw,
		 public Axis_Base {
public:
  Gtk_Axis(Axis_Base::alignment_t a);
  virtual ~Gtk_Axis();

protected:
  GtkOrientation orientation_;

  virtual gint button_press_event_impl(GdkEventButton* be);
  virtual gint configure_event_impl(GdkEventConfigure* ce);
  virtual gint motion_notify_event_impl(GdkEventMotion* me);

  void redraw();

private:

};

#endif
