// -*- C++ -*-

/* 
 * named.h 
 *
 * Copyright (C) 1998 EMC Capital Management, Inc.
 *
 * Developed by Jon Trowbridge <trow@emccta.com> and
 * Havoc Pennington <hp@emccta.com>.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#ifndef GUPPI_NAMED_H
#define GUPPI_NAMED_H

// Objects with names.

// I guess this is a tiny amount of functionality to bother sharing,
//  but I am too lazy to type it lots. 

#include <string>
#include <gtk--sig.h>

class Named {
public:
  
  Named(const char* name);

  virtual ~Named() {}
  
  void set_name(const char* name) { 
    name_ = name; 
    named_callback(name_);
  }
  void set_name(const string & name) { 
    name_ = name; 
    named_callback(name_);
  }
  const string & get_name() const { return name_; }

protected:
  virtual void named_callback(const string & name) = 0;
  
private:
  string name_;

  static guint num_instances_ = 0;
};


#endif
