// -*- C++ -*-

/* 
 * plot.h 
 *
 * Copyright (C) 1998 EMC Capital Management, Inc.
 *
 * Developed by Jon Trowbridge <trow@emccta.com> and
 * Havoc Pennington <hp@emccta.com>.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#ifndef GUPPI_PLOT_H
#define GUPPI_PLOT_H

// Abstract interface for plots, plus a little frame
//  all plots have around them (so we can use signals
//  and treat this as a widget)

// This basically abstracts the use of the Gtk_Plot,
//  which could allow us to plug GnomeCanvas, or 
//  be useful if a PlotDoc type didn't want to use
//  Gtk_Plot for some reason.

#include "gtkplot.h"

class Plot : public Gtk_Frame {
public:
  Plot();
  ~Plot();

  // Current X, Y; Width, Height
  Signal4<gdouble,gdouble,gdouble,gdouble> coordinates;
  // X origin, Y origin, xpos, ypos
  Signal4<gdouble,gdouble,gdouble,gdouble> rubberband_coordinates;

protected:
  // Pass the Gtk_Plot signals out to the Plot signals.
  void connect_gtkplot(Gtk_Plot& gp);

private:

};

#endif
