// -*- C++ -*-

/* 
 * plotedit.h 
 *
 * Copyright (C) 1998 EMC Capital Management, Inc.
 *
 * Developed by Jon Trowbridge <trow@emccta.com> and
 * Havoc Pennington <hp@emccta.com>.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#ifndef GUPPI_PLOTEDIT_H
#define GUPPI_PLOTEDIT_H

// This "bridges" the columns and the plots, giving you a 
//  way to edit their association.

// It should NOT have anything to do with PlotWindow, except
//  via PlotDoc. 

#include <list>
#include <gnome--.h>
#include "guppidoc.h"
#include "plotdoc.h"

class PlotEditImpl;

class PlotEdit : public Gtk_Window {
public:
  // The PlotDoc had better belong to the GuppiDoc 
  //  or you have a mess.
  PlotEdit(PlotDoc & pd, GuppiDoc & gd);
  ~PlotEdit();

protected:
  void self_munch();

private:
  PlotEditImpl* impl_;
  gint delete_event_impl(GdkEventAny * e) { self_munch(); return TRUE; }
};


#endif
