// -*- C++ -*-

/* 
 * redrawer.cc
 *
 * Copyright (C) 1998 EMC Capital Management, Inc.
 *
 * Developed by Jon Trowbridge <trow@emccta.com> and
 * Havoc Pennington <hp@emccta.com>.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#include "redrawer.h"

Redrawer::~Redrawer()
{
  // prevents redrawing a destroyed buffer, assuming the
  //  buffer properly destroys the redrawer.
  if (idle_connected_) {
    c.disconnect();
  }
}

void 
Redrawer::queue()
{
  if (!idle_connected_) {
    c = connect_to_method(Gtk_Main::idle(), 
			  this,
			  &Redrawer::redrawidle);
    idle_connected_ = true;
#ifdef GNOME_ENABLE_DEBUG
    g_print("Queued redraw\n");
#endif
  }
}

gint
Redrawer::redrawidle()
{
  g_assert(idle_connected_);
  
  gdb_.redraw();
#ifdef GNOME_ENABLE_DEBUG
  g_print("Redrew.", *i);
#endif
  
  idle_connected_ = false;
  return 0; // causes disconnect
}

